var babel = require('babel')
	, extend = require('lodash').extend

	, SETTINGS = {
			whitelist: [
				'es6.arrowFunctions',
				'es6.blockScoping',
				'es6.classes',
				'es6.constants',
				'es6.destructuring',
				'es6.forOf',
				'es6.modules',
				'es6.objectSuper',
				'es6.parameters.default',
				'es6.parameters.rest',
				'es6.properties.computed',
				'es6.properties.shorthand',
				'es6.regex.sticky',
				'es6.regex.unicode',
				'es6.spread',
				'es6.tailCall',
				'es6.templateLiterals'
			]
		};

/**
 * Retrieve registration data
 */
exports.registration = {
	name: 'babel',
	extensions: [
		'es6',
		'es7',
		'js'
	]
};

/**
 * Compile 'content'
 * @param {String} content
 * @param {Object} options
 * @param {Function} fn(err, content)
 */
exports.compile = function (content, options, fn) {
	try {
		content = babel.transform(content, extend({}, SETTINGS)).code;
		fn(null, content);
	} catch (err) {
		err.filepath = options.filepath;
		fn(err);
	}
};
